MyGuildMOTD = LibStub("AceAddon-3.0"):NewAddon("MyGuildMOTD", "AceConsole-3.0", "AceTimer-3.0")

local GM = MyGuildMOTD
local version = "v2.5.15a"
local ModName = "My Guild MOTD "..version

local WHITE		= "|cFFFFFFFF"
local RED		= "|cFFFF0000"
local GREEN		= "|cFF00FF00"
local YELLOW		= "|cFFFFFF00"
local ORANGE		= "|cFFFF7F00"
local TEAL		= "|cFF00FF9A"
local GOLD		= "|cFFFFD700"

local GMActiveTimer
local MyplayerName = UnitName("player")
local total = 0
local DATE = tonumber(date("%j"))
local MyVariablesLoaded = 0

MyGuildMOTDVars = {}
local MyGMOTDResetter = 0
local MyGuildMOTDIsOpen = 0

local frame = CreateFrame("Frame");

local function WatchDog(self, event, message, sender, arg1, arg2, ...)

  MYMOTD = GetGuildRosterMOTD()
  if MYMOTD ~= nil then
	if event == "PLAYER_ENTERING_WORLD" then
		GuildRoster() -- Forces a Roster Update when entering/exiting instances, etc.
		if MYOPTION1 == nil then MYOPTION1 = MyGuildMOTDVars.MYSAVEDOPTION1 or false end
		if MYOPTION2 == nil then MYOPTION2 = MyGuildMOTDVars.MYSAVEDOPTION2 or false end
		if MYOPTION3 == nil then MYOPTION3 = MyGuildMOTDVars.MYSAVEDOPTION3 or false end
		if MyGuildMOTDVars.ICON == nil then MyGuildMOTDVars.ICON = 0 end
		if MyGuildMOTDVars.ICONBa == nil then
		MyGuildMOTDVars.ICONBa = "CENTER"
		MyGuildMOTDVars.ICONBb = "Minimap"
		MyGuildMOTDVars.ICONBc = "CENTER"
		MyGuildMOTDVars.ICONBx = 66
		MyGuildMOTDVars.ICONBy = -165
		end
		MyGMVariablesLoaded = 1
		return;

	elseif event == "GUILD_ROSTER_UPDATE" then
		MyGuildMOTDVars.GuildName = GetGuildInfo("player")
		if MyGuildMOTDFrame == nil and MyGMVariablesLoaded == 1 then GM:LoadGUI() end

		if MyGuildMOTDICON ~= nil then
		    MyGuildMOTDICON:ClearAllPoints()
		    MyGuildMOTDICON:SetPoint(MyGuildMOTDVars.ICONBa, MyGuildMOTDVars.ICONBb, MyGuildMOTDVars.ICONBc, MyGuildMOTDVars.ICONBx, MyGuildMOTDVars.ICONBy)
		    if MyGuildMOTDVars.ICON == 0 then
		    MyGuildMOTDICON:Show()
		    MyGuildMOTDICONB:Show()
		    else
		    MyGuildMOTDICONB:Hide()
		    end
		end
		return;

	elseif event == "PLAYER_LOGOUT" then
	MyGuildMOTDTimerLeft = (math.ceil((GM:TimeLeft(GMActiveTimer))/60))
	MyGuildMOTDVars.ADM = IncludeADM:GetChecked()
	MyGuildMOTDVars.QOTD = IncludeQOTD:GetChecked()

	return;

	elseif event == "GUILD_MOTD" then
	if MyGMOTDResetter ~= 1 then
	   GM:SetUpTimer(MyGuildMOTDTimer)
	   GM:Print("Guild MOTD changed or rebroadcasted by someone.\nYour timer has been reset to "..MyGuildMOTDTimer.." minutes.")
	   GM:GetMyGuildMOTD()	
	MyGMOTDResetter = 0
	end

	return;

	else
	GM:Print(event) -- Debugging Purposes
        end
   else
   end
end

--frame:RegisterAllEvents()
frame:RegisterEvent("GUILD_MOTD")
frame:RegisterEvent("PLAYER_LOGOUT")
frame:RegisterEvent("GUILD_ROSTER_UPDATE")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

frame:SetScript("OnEvent", WatchDog)


---------------------------------------------------------------------------
local function MyonUpdate(self, elapsed)
   if MyGuildMOTDTimerDisplay ~= nil then -- Makes sure that this frame has been drawn before we try to start keeping it updated.
      total = total + elapsed

	if MyGuildMOTDFrame ~= nil then

	   if not MyGuildMOTDFrame:IsVisible() and MyGuildMOTDIsOpen == 1 then
		PlaySound("igCharacterInfoClose")
		MyGuildMOTDIsOpen = 0
	   end
	end
   end
----------------------------------------------------------------------------


-- Make sure that we have the correct remaining time left displayed and centered on the bubble.
    if total >= 5 then -- Updating every 5 seconds

	if MyGuildMOTDTimer == 0 then -- Timer has been disabled...
	MyGuildMOTDTimerDisplay:SetText("off")
	return;
	end
	
	MyGuildMOTDTimerLeft = (math.ceil((GM:TimeLeft(GMActiveTimer))/60)) 
	if MyGuildMOTDTimerLeft > 199 then
	MyGuildMOTDTimerDisplay:SetText(MyGuildMOTDTimerLeft)
	MyGuildMOTDICONDisplay:SetText(" "..MyGuildMOTDTimerLeft)

	elseif MyGuildMOTDTimerLeft > 99 then
	MyGuildMOTDTimerDisplay:SetText(MyGuildMOTDTimerLeft)
	MyGuildMOTDICONDisplay:SetText(MyGuildMOTDTimerLeft)

	elseif MyGuildMOTDTimerLeft >= 10 then
	MyGuildMOTDTimerDisplay:SetText(" "..MyGuildMOTDTimerLeft)
	MyGuildMOTDICONDisplay:SetText(MyGuildMOTDTimerLeft)

	elseif MyGuildMOTDTimerLeft < 10 then
	MyGuildMOTDTimerDisplay:SetText("  "..MyGuildMOTDTimerLeft)
	MyGuildMOTDICONDisplay:SetText(MyGuildMOTDTimerLeft)
	else

        end
        total = 0
    end
end

local f = CreateFrame("frame")
f:SetScript("OnUpdate", MyonUpdate)

MyGMConfigOptions = {
	name = "MyGuildMOTD "..version,
	type = 'group',
	args = {
		confdesc = {
			order = 1,
			type = "description",
			name = "Options for the Graphical User Interface",
			cmdHidden = true
			},
		CONFIG = {
			order = 2,
			name = "TOGGLE",
			desc = "Opens MyGuildMOTD GUI",
			type = 'execute',
			func = function()
			GM:CFToggle()
			end
			},
		RESET = {
			order = 3,
			name = "RESET ICON",
			desc = "Resets the location of the Toggle Icon to the default position. \nMay not take effect until your next screen reload.",
			type = 'execute',
			func = function()
			   if not MyGuildMOTDICONB then
			   GM:LoadGUI()
		           end
			MyGuildMOTDVars.ICON = 0
			MyGuildMOTDVars.ICONBa = "CENTER"
			MyGuildMOTDVars.ICONBb = "Minimap"
			MyGuildMOTDVars.ICONBc = "CENTER"
			MyGuildMOTDVars.ICONBx = 66
			MyGuildMOTDVars.ICONBy = -165
			MyGuildMOTDICON:ClearAllPoints()
			MyGuildMOTDICON:Hide()
			MyGuildMOTDICON:SetPoint(MyGuildMOTDVars.ICONBa, MyGuildMOTDVars.ICONBb, MyGuildMOTDVars.ICONBc, MyGuildMOTDVars.ICONBx, MyGuildMOTDVars.ICONBy)
			MyGuildMOTDICON:Show()
			MyGuildMOTDICONB:Show()
			end
			},
		DISABLE = {
			order = 4,
			name = "HIDE/SHOW ICON",
			desc = "Hide/Show the Toggle Icon",
			type = 'execute',
			func = function()
			   if not MyGuildMOTDICONB then
			   GM:LoadGUI()
		           end
			if MyGuildMOTDICONB:IsVisible() then
			MyGuildMOTDVars.ICON = 1
			MyGuildMOTDICONB:Hide()
			else
			MyGuildMOTDVars.ICON = 0
			MyGuildMOTDICONB:Show()
			end
			end
			},


		}

}


function GM:OnInitialize()
	
        MyGuildMOTDVars.GuildName = MyGuildMOTDVars.GuildName or GetGuildInfo("player")
	GM:MyQuote()
	MyGuildMOTDTimer = MyGuildMOTDTimer or 45
	MyGuildMOTDTimerLeft = MyGuildMOTDTimerLeft or 15
	MyGuildMOTDVars.MyDelay = MyGuildMOTDVars.MyDelay or 8
	MyGuildMOTDDefault = MyGuildMOTDDefault or "Default Additional Guild Message"
	GM:RegisterChatCommand("MyGuildMOTD", "Slash")
	GM:RegisterChatCommand("MyGMOTD", "Slash")
	MyGuildMOTDVars.tooltip = YELLOW..ModName..WHITE.."\nLeft-click to "..GREEN.."Toggle.\n"..WHITE.."Right-click to "..GREEN.."Drag."

    local AC = LibStub('AceConfig-3.0')
    local ACD = LibStub('AceConfigDialog-3.0')

    AC:RegisterOptionsTable("MyGuildMOTD", MyGMConfigOptions)
    MyGuildMOTD.optionsFrame = ACD:AddToBlizOptions("MyGuildMOTD", "MyGuildMOTD")


end

function GM:GetMyGuildMOTD()
	self:ScheduleTimer("FetchMyGuildMOTD", 5)
end

function GM:FetchMyGuildMOTD()
	MYMOTD = GetGuildRosterMOTD()
end

function GM:SetUpTimer()

	if GM:TimeLeft(GMActiveTimer) then
		GM:CancelTimer(GMActiveTimer)

	end
	if MyGuildMOTDTimer > 0 then
		GMActiveTimer = GM:ScheduleRepeatingTimer("BroadcastMessage", max(MyGuildMOTDTimer, 1)*60) -- Minimum interval is 1 Minute.
	end
end

function GM:LoadGUI()
	if MyGMGUIShown ~= 1 and MyGMVariablesLoaded == 1 then
	GM:ShowGUI()

	MyGMGUIShown = 1

   	if MyGuildMOTDTimer == nil then -- Just in case this is the first time running the mod.
	MyGuildMOTDTimer = 45
	GMActiveTimer = GM:ScheduleRepeatingTimer("BroadcastMessage", max(MyGuildMOTDTimer, 1)*60) -- Set timer for first use.
	return;	      
	else
	GMActiveTimer = GM:ScheduleRepeatingTimer("BroadcastMessage", max(MyGuildMOTDTimerLeft, 1)*60) -- Short timer for between logins...character changes, etc.
	return;
	end
    end
end

function GM:MyQuote()

    if MyGuildMOTDVars.MQ == 1 then QUOTE = MyNIVEnglishBibleQuotes[DATE]
elseif MyGuildMOTDVars.MQ == 2 then QUOTE = MyPresidentialQuotes[DATE]
elseif MyGuildMOTDVars.MQ == 3 then QUOTE = MyHumorousQuotes[DATE]
    else
    QUOTE = "Please select a type of Quote from the dropdown menu on the lower left of this window!"
    end

end

function GM:MyGuildMOTDSave()
MyGuildMOTDVars.ICONBa, MyGuildMOTDVars.ICONBb, MyGuildMOTDVars.ICONBc, MyGuildMOTDVars.ICONBx, MyGuildMOTDVars.ICONBy = MyGuildMOTDICONB:GetPoint()
end

-- Making the GUI
function GM:ShowGUI()

local MyGuildMOTDFrame = CreateFrame("Frame", "MyGuildMOTDFrame", UIParent)
MyGuildMOTDFrame:SetFrameStrata("BACKGROUND")
MyGuildMOTDFrame:SetPoint("CENTER", 0, 92)
MyGuildMOTDFrame:SetWidth(512)
MyGuildMOTDFrame:SetHeight(512)
MyGuildMOTDFrame:Hide()
MyGuildMOTDFrame:SetHitRectInsets(0, 165, 0, 100)

local GMTexture = MyGuildMOTDFrame:CreateTexture("GTexture", "BACKGROUND", MyGuildMOTDFrame)
SetPortraitToTexture(GTexture, "Interface\\Icons\\INV_Letter_03")
GMTexture:SetPoint("TOPLEFT", 11, -6)
GMTexture:SetWidth(60)
GMTexture:SetHeight(60)

local GMtexture = MyGuildMOTDFrame:CreateTexture(nil, "BORDER", MyGuildMOTDFrame)
GMtexture:SetTexture("Interface\\LFGFRAME\\UI-FRAME-THREEBUTTON-BLANK")
GMtexture:SetAllPoints(MyGuildMOTDFrame)

local GMCButton = CreateFrame("Button", nil, MyGuildMOTDFrame, "UIPanelCloseButton")
GMCButton:SetFrameStrata("MEDIUM")
GMCButton:ClearAllPoints()
GMCButton:SetPoint("CENTER", 87, 232)

local GuildNameTitle = MyGuildMOTDFrame:CreateFontString("GuildNameTitle", "ARTWORK")
GuildNameTitle:SetFont("Fonts\\MORPHEUS.ttf", 18, "OUTLINE")
GuildNameTitle:SetPoint("TOP", -61, -15)
GuildNameTitle:SetTextColor(1, 1, 0)
GuildNameTitle:SetText("My Guild MOTD")

MyGuildMOTDTitle = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDTitle", "ARTWORK")
MYGMFS = 58 - 1.32*(string.len(tostring(MyGuildMOTDVars.GuildName)))
MyGuildMOTDTitle:SetFont("Fonts\\MORPHEUS.ttf", MYGMFS, "OUTLINE")
MYGMFL = -37 - .5*(string.len(tostring(MyGuildMOTDVars.GuildName)))
MyGuildMOTDTitle:SetPoint("TOP", -61, MYGMFL)
MyGuildMOTDTitle:SetTextColor(1, .42, 0)
MyGuildMOTDTitle:SetText(MyGuildMOTDVars.GuildName)

MyGuildMOTDTimerDisplay = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDTimerDisplay", "ARTWORK")
MyGuildMOTDTimerDisplay:SetFont("Fonts\\MORPHEUS.ttf", 35, "OUTLINE")
MyGuildMOTDTimerDisplay:SetPoint("TOPLEFT", 14, -17)
MyGuildMOTDTimerDisplay:SetText(" "..MyGuildMOTDTimerLeft)

MyGuildMOTDMOTDTitle = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDMOTDTitle", "ARTWORK")
MyGuildMOTDMOTDTitle:SetFont("Fonts\\MORPHEUS.ttf", 15, "OUTLINE")
MyGuildMOTDMOTDTitle:SetPoint("TOP", -62, -85)
MyGuildMOTDMOTDTitle:SetTextColor(1,1,0)
MyGuildMOTDMOTDTitle:SetText("Guild Message of the Day")

MyGuildMOTDMOTD = CreateFrame("EditBox", "MOTDInput", MyGuildMOTDFrame, "InputBoxTemplate")
MyGuildMOTDMOTD:SetWidth(293)
MyGuildMOTDMOTD:SetHeight(25)
MyGuildMOTDMOTD:SetPoint("TOPLEFT", 40, -100)
MyGuildMOTDMOTD:SetMaxLetters(128)
MyGuildMOTDMOTD:SetAutoFocus(false)
MyGuildMOTDMOTD:SetText(MYMOTD)
MyGuildMOTDMOTD:SetScript("OnEnterPressed", function(self)
MYMOTD = MyGuildMOTDMOTD:GetText()
MyGuildMOTDMOTDDisplay:SetText(MYMOTD) -- Submitting new message to be broadcasted.
MyGuildMOTDMOTD:ClearFocus()
GM:BroadcastMessage()
end)
MyGuildMOTDMOTD:SetScript("OnTextChanged", function(self, isUserInput)
TempMOTD = MyGuildMOTDMOTD:GetText() -- Displaying message as we type.
MyGuildMOTDMOTDDisplay:SetText(TempMOTD)
end)
MyGuildMOTDMOTD:SetScript("OnEditFocusLost", function(self)
MyGuildMOTDMOTDDisplay:SetText(MYMOTD) -- Revert back to old message...nothing was confirmed.
MyGuildMOTDMOTD:SetText(MYMOTD) -- Restore old MOTD to the edit box
end)



MyGuildMOTDMOTDDisplay = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDMOTDDisplay", "ARTWORK")
MyGuildMOTDMOTDDisplay:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
MyGuildMOTDMOTDDisplay:SetPoint("TOPLEFT", 39, -103)
MyGuildMOTDMOTDDisplay:SetWidth(290)
MyGuildMOTDMOTDDisplay:SetHeight(100)
MyGuildMOTDMOTDDisplay:SetNonSpaceWrap(true)
MyGuildMOTDMOTDDisplay:SetWordWrap(true)
MyGuildMOTDMOTDDisplay:SetText(MYMOTD)

local IncludeADM = CreateFrame("CheckButton", "IncludeADM", MyGuildMOTDFrame, "UICheckButtonTemplate")
IncludeADM:SetPoint("TOPLEFT", 254, -182)
if MyGuildMOTDVars.ADM ~= nil then IncludeADM:SetChecked(true) end
_G[IncludeADM:GetName() .. "Text"]:SetText("Include?")

MyGuildMOTDADMTitle = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDADMTitle", "ARTWORK")
MyGuildMOTDADMTitle:SetFont("Fonts\\MORPHEUS.ttf", 15, "OUTLINE")
MyGuildMOTDADMTitle:SetPoint("TOP", -81, -191)
MyGuildMOTDADMTitle:SetTextColor(1,1,0)
MyGuildMOTDADMTitle:SetText("Additional Message")

local MyGuildMOTDADM = CreateFrame("EditBox", "ADMInput", MyGuildMOTDFrame, "InputBoxTemplate")
MyGuildMOTDADM:SetWidth(293)
MyGuildMOTDADM:SetHeight(25)
MyGuildMOTDADM:SetPoint("TOPLEFT", 40, -203)
MyGuildMOTDADM:SetMaxLetters(255)
MyGuildMOTDADM:SetAutoFocus(false)
MyGuildMOTDADM:SetText(MyGuildMOTDDefault)
MyGuildMOTDADM:SetScript("OnEnterPressed", function(self)
MyGuildMOTDDefault = MyGuildMOTDADM:GetText()
MyGuildMOTDADM:SetText(MyGuildMOTDDefault) -- Submitting new message to be broadcasted.
MyGuildMOTDADM:ClearFocus()
end)
MyGuildMOTDADM:SetScript("OnTextChanged", function(self, isUserInput)
TempMyGuildMOTDDefault = MyGuildMOTDADM:GetText() -- Displaying message as we type.
MyGuildMOTDADMDisplay:SetText(TempMyGuildMOTDDefault)
end)
MyGuildMOTDADM:SetScript("OnEditFocusLost", function(self)
MyGuildMOTDADMDisplay:SetText(MyGuildMOTDDefault) -- Revert back to old message...nothing was confirmed.
MyGuildMOTDADM:SetText(MyGuildMOTDDefault) -- Restore old Message to the edit box
end)

MyGuildMOTDADMDisplay = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDADMDisplay", "ARTWORK")
MyGuildMOTDADMDisplay:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
MyGuildMOTDADMDisplay:SetPoint("TOPLEFT", 22, -205)
MyGuildMOTDADMDisplay:SetWidth(328)
MyGuildMOTDADMDisplay:SetHeight(100)
MyGuildMOTDADMDisplay:SetNonSpaceWrap(true)
MyGuildMOTDADMDisplay:SetWordWrap(true)
MyGuildMOTDADMDisplay:SetText(MyGuildMOTDDefault)

GuildTimerText = MyGuildMOTDFrame:CreateFontString("GuildTimerText", "ARTWORK")
GuildTimerText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
GuildTimerText:SetPoint("TOP", -74, -290)
GuildTimerText:SetTextColor(1,1,0)
GuildTimerText:SetText("Guild Broadcast Interval set at         minutes.")

local GuildTimer = CreateFrame("EditBox", "GuildTimer", MyGuildMOTDFrame, "InputBoxTemplate")
GuildTimer:SetWidth(26)
GuildTimer:SetHeight(25)
GuildTimer:SetPoint("TOPLEFT", 239, -282)
GuildTimer:SetMaxLetters(3)
GuildTimer:SetAutoFocus(false)
GuildTimer:SetText(MyGuildMOTDTimer)
GuildTimer:SetScript("OnEnterPressed", function(self)
TempTimer = GuildTimer:GetText()
   if tonumber(TempTimer) then
	MyGuildMOTDTimer = math.abs(max(tonumber(TempTimer),0))
	if MyGuildMOTDTimer > 999 then
	GM:Print("Maximum timer value is 999!")
	return;
	elseif MyGuildMOTDTimer == 0 then
	GM:Print("Guild MOTD Broadcast disabled.\n                 Enter a value between 1-999 to enable.")
	GuildTimer:ClearFocus()
	return;
	else
	GM:SetUpTimer(MyGuildMOTDTimer)
	GM:Print("Guild MOTD Broadcast changed to "..MyGuildMOTDTimer.." minutes.")
	GuildTimer:ClearFocus()
	return;
  	end
   end
GuildTimer:SetText(MyGuildMOTDTimer)
end)
GuildTimer:SetScript("OnEditFocusLost", function(self)
GuildTimer:SetText(MyGuildMOTDTimer) -- Revert back to old time displayed...nothing was confirmed.
end)

MyGuildMOTDQUOTETitle = MyGuildMOTDFrame:CreateFontString("MyGuildMOTDQUOTETitle", "ARTWORK")
MyGuildMOTDQUOTETitle:SetFont("Fonts\\MORPHEUS.ttf", 15, "OUTLINE")
MyGuildMOTDQUOTETitle:SetPoint("TOP", -81, -315)
MyGuildMOTDQUOTETitle:SetTextColor(1,1,0)
MyGuildMOTDQUOTETitle:SetText("Quote of the Day")

local IncludeQOTD = CreateFrame("CheckButton", "IncludeQOTD", MyGuildMOTDFrame, "UICheckButtonTemplate")
IncludeQOTD:SetPoint("TOPLEFT", 254, -305)

if MyGuildMOTDVars.QOTD ~= nil then IncludeQOTD:SetChecked(true) end
_G[IncludeQOTD:GetName() .. "Text"]:SetText("Include?")

local BroadCastNow = CreateFrame("Button", "BroadCastNow", MyGuildMOTDFrame, "UIPanelButtonTemplate")
BroadCastNow:SetFrameStrata("HIGH")
BroadCastNow:SetWidth(130)
BroadCastNow:SetHeight(22)
BroadCastNow:SetPoint("CENTER", 28, -162)
BroadCastNow:SetText("Broadcast Now!")
BroadCastNow:RegisterForClicks("AnyDown")
BroadCastNow:SetScript("OnClick", function(self, button, down)
	GM:BroadcastMessage()
	end)

GuildQuoteOTD = MyGuildMOTDFrame:CreateFontString("GuildQuoteOTD", "ARTWORK")
GuildQuoteOTD:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
GuildQuoteOTD:SetPoint("TOPLEFT", 24, -314)
GuildQuoteOTD:SetWidth(290)
GuildQuoteOTD:SetHeight(100)
GuildQuoteOTD:SetWordWrap(true)
GuildQuoteOTD:SetText(QUOTE)

-- Making the Quotes Drop Down Menu

local MYmenu = {
		{text = "Bible Verses", checked = function() return MYOPTION1 end, func = function() MyGuildMOTDVars.MYSAVEDOPTION1 = not MyGuildMOTDVars.MYSAVEDOPTION1 GM:MOTDLogic(1) end},
		{text = "Presidents", checked = function() return MYOPTION2 end, func = function() MyGuildMOTDVars.MYSAVEDOPTION2 = not MyGuildMOTDVars.MYSAVEDOPTION2  GM:MOTDLogic(2) end},
		{text = "Humorous", checked = function() return MYOPTION3 end, func = function() MyGuildMOTDVars.MYSAVEDOPTION3 = not MyGuildMOTDVars.MYSAVEDOPTION3  GM:MOTDLogic(3) end},
	     }
local MyGuildMOTDMenu = CreateFrame("Frame", "MyGuildMOTDMenu", MyGuildMOTDFrame, "UIDropDownMenuTemplate")
local MyGuildMOTDButton = CreateFrame("Button", "MyGuildMOTDButton", MyGuildMOTDFrame, "GameMenuButtonTemplate")
MyGuildMOTDButton:SetFrameStrata("HIGH")
MyGuildMOTDButton:SetWidth(125)
MyGuildMOTDButton:SetHeight(22)
MyGuildMOTDButton:SetText("Quote Options")
MyGuildMOTDButton:SetPoint("TOPLEFT", 21, -406)
MyGuildMOTDButton:SetScript("OnClick", function(self, button)
EasyMenu(MYmenu, MyGuildMOTDMenu, MyGuildMOTDButton, 0, 0, nil, 10)
end)


local MyGuildMOTDConfigButton = CreateFrame("Button", "MyGuildMOTDConfigButton", MyGuildMOTDFrame, "UIPanelButtonTemplate")
MyGuildMOTDConfigButton:SetFrameStrata("HIGH")
MyGuildMOTDConfigButton:SetWidth(80)
MyGuildMOTDConfigButton:SetHeight(22)
MyGuildMOTDConfigButton:SetPoint("CENTER", -74, -162)
MyGuildMOTDConfigButton:SetText("CONFIG")

MyGuildMOTDConfigButton:RegisterForClicks("AnyDown")
MyGuildMOTDConfigButton:SetScript("OnClick", function(self, button, down)
	GM:CFToggle2()
PlaySound("igMainMenuOptionCheckBoxOn")
	end)



-- Configuration Menu Frame


local MyGuildMOTDConfigFrame = CreateFrame("Frame", "MyGuildMOTDConfigFrame", MyGuildMOTDFrame)
MyGuildMOTDConfigFrame:SetFrameStrata("MEDIUM")
MyGuildMOTDConfigFrame:SetPoint("TOPLEFT", 1, 0)
MyGuildMOTDConfigFrame:SetWidth(512)
MyGuildMOTDConfigFrame:SetHeight(512)
MyGuildMOTDConfigFrame:Hide()
MyGuildMOTDConfigFrame:SetHitRectInsets(0, 165, 0, 100)

local CFtexture = MyGuildMOTDConfigFrame:CreateTexture(nil, "BACKGROUND", MyGuildMOTDFrame)
CFtexture:SetTexture("Interface\\LFGFRAME\\UI-LFR-FRAME-MAIN.png")
CFtexture:SetAllPoints(MyGuildMOTDConfigFrame)

CFGuildNameTitle = MyGuildMOTDConfigFrame:CreateFontString("CFGuildNameTitle", "ARTWORK")
CFGuildNameTitle:SetFont("Fonts\\MORPHEUS.ttf", 18, "OUTLINE")
CFGuildNameTitle:SetPoint("TOP", -61, -15)
CFGuildNameTitle:SetTextColor(1, 1,0)
CFGuildNameTitle:SetText("My Guild MOTD")

CFMyGuildMOTDTitle = MyGuildMOTDConfigFrame:CreateFontString("CFMyGuildMOTDTitle", "ARTWORK")
CFMyGuildMOTDTitle:SetFont("Fonts\\MORPHEUS.ttf", MYGMFS, "OUTLINE")
CFMyGuildMOTDTitle:SetPoint("TOP", -61, MYGMFL)
CFMyGuildMOTDTitle:SetTextColor(1, .42,0)
CFMyGuildMOTDTitle:SetText(MyGuildMOTDVars.GuildName)

CFDelayTimerText = MyGuildMOTDConfigFrame:CreateFontString("CFDelayTimerText", "ARTWORK")
CFDelayTimerText:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
CFDelayTimerText:SetPoint("TOP", -70, -95)
CFDelayTimerText:SetTextColor(1,1,0)
CFDelayTimerText:SetText("Delay between messages is set at         seconds.")

local CFGuildTimer = CreateFrame("EditBox", "CFGuildTimer", MyGuildMOTDConfigFrame, "InputBoxTemplate")
CFGuildTimer:SetWidth(20)
CFGuildTimer:SetHeight(25)
CFGuildTimer:SetPoint("TOPLEFT", 257, -87)
CFGuildTimer:SetMaxLetters(2)
CFGuildTimer:SetAutoFocus(false)
CFGuildTimer:SetText(MyGuildMOTDVars.MyDelay)
CFGuildTimer:SetScript("OnEnterPressed", function(self)
CFTempTimer = CFGuildTimer:GetText()
   if tonumber(CFTempTimer) then
	CFTempTimer = math.abs(max(tonumber(CFTempTimer),0))
	if CFTempTimer > 20 then
	GM:Print("Maximum Delay value is 20!")
	return;
	else
	MyGuildMOTDVars.MyDelay = CFTempTimer
	GM:Print("Guild MOTD Message Delays changed to "..MyGuildMOTDVars.MyDelay.." seconds.")
	CFGuildTimer:ClearFocus()
	return;
  	end
   end
CFGuildTimer:SetText(MyGuildMOTDVars.MyDelay)
end)
CFGuildTimer:SetScript("OnEditFocusLost", function(self)
CFGuildTimer:SetText(MyGuildMOTDVars.MyDelay) -- Revert back to old timer displayed...nothing was confirmed.
end)

local MyGuildMOTDICONResetButton = CreateFrame("Button", "MyGuildMOTDICONResetButton", MyGuildMOTDConfigFrame, "UIPanelButtonTemplate")
MyGuildMOTDICONResetButton:SetFrameStrata("HIGH")
MyGuildMOTDICONResetButton:SetWidth(100)
MyGuildMOTDICONResetButton:SetHeight(22)
MyGuildMOTDICONResetButton:SetPoint("CENTER", -180, 118)
MyGuildMOTDICONResetButton:SetText("RESET ICON")

MyGuildMOTDICONResetButton:RegisterForClicks("AnyDown")
MyGuildMOTDICONResetButton:SetScript("OnClick", function(self, button, down)
	MyGuildMOTDVars.ICON = 0
	MyGuildMOTDVars.ICONBa = "CENTER"
	MyGuildMOTDVars.ICONBb = "Minimap"
	MyGuildMOTDVars.ICONBc = "CENTER"
	MyGuildMOTDVars.ICONBx = 66
	MyGuildMOTDVars.ICONBy = -165
	MyGuildMOTDICONB:ClearAllPoints()
	MyGuildMOTDICONB:Hide()
	MyGuildMOTDICON:SetPoint(MyGuildMOTDVars.ICONBa, MyGuildMOTDVars.ICONBb, MyGuildMOTDVars.ICONBc, MyGuildMOTDVars.ICONBx, MyGuildMOTDVars.ICONBy)
	MyGuildMOTDICON:Show()
	MyGuildMOTDICONB:Show()
	PlaySound("igMainMenuOptionCheckBoxOn")
	end)

local MyGuildMOTDICONResetButton = CreateFrame("Button", "MyGuildMOTDICONResetButton", MyGuildMOTDConfigFrame, "UIPanelButtonTemplate")
MyGuildMOTDICONResetButton:SetFrameStrata("HIGH")
MyGuildMOTDICONResetButton:SetWidth(100)
MyGuildMOTDICONResetButton:SetHeight(22)
MyGuildMOTDICONResetButton:SetPoint("CENTER", -180, 118)
MyGuildMOTDICONResetButton:SetText("RESET ICON")

MyGuildMOTDICONResetButton:RegisterForClicks("AnyDown")
MyGuildMOTDICONResetButton:SetScript("OnClick", function(self, button, down)
	MyGuildMOTDVars.ICON = 0
	MyGuildMOTDVars.ICONBa = "CENTER"
	MyGuildMOTDVars.ICONBb = "Minimap"
	MyGuildMOTDVars.ICONBc = "CENTER"
	MyGuildMOTDVars.ICONBx = 66
	MyGuildMOTDVars.ICONBy = -165
	MyGuildMOTDICON:ClearAllPoints()
	MyGuildMOTDICON:Hide()
	MyGuildMOTDICONB:Hide()
	MyGuildMOTDICON:SetPoint(MyGuildMOTDVars.ICONBa, MyGuildMOTDVars.ICONBb, MyGuildMOTDVars.ICONBc, MyGuildMOTDVars.ICONBx, MyGuildMOTDVars.ICONBy)
	MyGuildMOTDICON:Show()
	MyGuildMOTDICONB:Show()
	PlaySound("igMainMenuOptionCheckBoxOn")
	end)

local MyGuildMOTDICONToggleButton = CreateFrame("Button", "MyGuildMOTDICONToggleButton", MyGuildMOTDConfigFrame, "UIPanelButtonTemplate")
MyGuildMOTDICONToggleButton:SetFrameStrata("HIGH")
MyGuildMOTDICONToggleButton:SetWidth(150)
MyGuildMOTDICONToggleButton:SetHeight(22)
MyGuildMOTDICONToggleButton:SetPoint("CENTER", -60, 118)
MyGuildMOTDICONToggleButton:SetText("SHOW/HIDE ICON")

MyGuildMOTDICONToggleButton:RegisterForClicks("AnyDown")
MyGuildMOTDICONToggleButton:SetScript("OnClick", function(self, button, down)
	if MyGuildMOTDICONB:IsVisible() then
	MyGuildMOTDVars.ICON = 1
	MyGuildMOTDICONB:Hide()
	else
	MyGuildMOTDVars.ICON = 0
	MyGuildMOTDICONB:Show()
	end
	PlaySound("igMainMenuOptionCheckBoxOn")
	end)

-- Toggle ICON

local MyGuildMOTDICON = CreateFrame("Frame", "MyGuildMOTDICON", UIParent)
MyGuildMOTDICON:SetFrameStrata("BACKGROUND")
MyGuildMOTDICON:SetPoint("CENTER", "Minimap", "CENTER", 66, -165)
MyGuildMOTDICON:SetMovable(true)
MyGuildMOTDICON:SetUserPlaced(true)
MyGuildMOTDICON:EnableMouse(true)
MyGuildMOTDICON:SetWidth(37)
MyGuildMOTDICON:SetHeight(37)
MyGuildMOTDICON:SetHitRectInsets(0, 0, 0, 0)
MyGuildMOTDICON:Hide()

local MyGuildMOTDICONB = CreateFrame("Button", "MyGuildMOTDICONB", MyGuildMOTDICON, "SecureHandlerClickTemplate")
MyGuildMOTDICONB:SetFrameStrata("MEDIUM")
MyGuildMOTDICONB:SetSize(37,37)
MyGuildMOTDICONB:SetPoint("CENTER", 0, 0)
MyGuildMOTDICONB:SetNormalTexture("Interface\\Icons\\INV_Letter_03")
MyGuildMOTDICONB:SetHighlightTexture("Interface/BUTTONS/CheckButtonHilight")
MyGuildMOTDICONB:SetMovable(true)
MyGuildMOTDICONB:SetUserPlaced(true)
MyGuildMOTDICONB:EnableMouse(true)
MyGuildMOTDICONB:RegisterForClicks("Any")
MyGuildMOTDICONB:Hide()

MyGuildMOTDICONDisplay = MyGuildMOTDICONB:CreateFontString("MyGuildMOTDICONDisplay", "ARTWORK")
MyGuildMOTDICONDisplay:SetFont("Fonts\\MORPHEUS.ttf", 24, "OUTLINE")
MyGuildMOTDICONDisplay:SetPoint("CENTER", 0, 0)
MyGuildMOTDICONDisplay:SetText(MyGuildMOTDTimerLeft)

local MyGMButtonLabel = MyGuildMOTDICONB:CreateFontString("MyGMButtonLabel", "HIGH")
MyGMButtonLabel:SetFont("Fonts\\ARIALN.ttf", 12)
MyGMButtonLabel:SetPoint("TOP", 0, -40)
MyGMButtonLabel:SetTextColor(1, 1, 1)
MyGMButtonLabel:SetText("MOTD")

MyGuildMOTDICONB:SetScript("OnMouseDown", function(self, button, down)
	if button == "LeftButton" then
	GM:CFToggle();
	return;
	end
	
	if button == "RightButton" and not self.isMoving then   
	self:StartMoving();   
	self.isMoving = true;
	end  
	end)

MyGuildMOTDICONB:SetScript("OnMouseUp", function(self, button, up)
	if button == "RightButton" and self.isMoving then
	self:StopMovingOrSizing(GM:MyGuildMOTDSave());
	self.isMoving = false;
	end
	end)

MyGuildMOTDICONB:SetScript("OnEnter", function()
	ItemRefTooltip:SetOwner(MyGuildMOTDICONB, "MyGuildMOTDICONB")
	ItemRefTooltip:SetText(MyGuildMOTDVars.tooltip)
	ItemRefTooltip:Show()
	end)

MyGuildMOTDICONB:SetScript("OnLeave", function()
	ItemRefTooltip:Hide()
	end)


-- End of My GUI FRAME!
end

function GM:CFToggle()
   if MyGuildMOTDFrame:IsVisible() then
   MyGuildMOTDFrame:Hide()
   MyGuildMOTDConfigFrame:Hide()
PlaySound("igCharacterInfoClose")
   else
   GM:GetMyGuildMOTD()
   MyGuildMOTDMOTD:SetText(MYMOTD)
   MyGuildMOTDMOTDDisplay:SetText(MYMOTD)
	
	if MyGuildNotesFrame ~= nil then
	    MyGuildMOTDFrame:ClearAllPoints()
	    MyGuildMOTDFrameLocation = 275
	    MyGuildMOTDFrame:SetPoint("CENTER", MyGuildMOTDFrameLocation, 92)
	    else
	    MyGuildMOTDFrame:ClearAllPoints()
	    MyGuildMOTDFrameLocation = 0
	    MyGuildMOTDFrame:SetPoint("CENTER", MyGuildMOTDFrameLocation, 92)
	end
   MyGuildMOTDFrame:Show()
PlaySound("igCharacterInfoOpen")
   MyGuildMOTDIsOpen = 1
   end
end

function GM:CFToggle2()
   if MyGuildMOTDConfigFrame:IsVisible() then
   MyGuildMOTDConfigFrame:Hide()
   else
   MyGuildMOTDConfigFrame:Show()
   end
end


function GM:MOTDLogic(i)

   if MYOPTION1 ~= MyGuildMOTDVars.MYSAVEDOPTION1 then
	MyGuildMOTDVars.MYSAVEDOPTION1 = true
	MyGuildMOTDVars.MYSAVEDOPTION2 = false
	MyGuildMOTDVars.MYSAVEDOPTION3 = false
	MyGuildMOTDVars.MYSAVEDOPTION4 = false
	MYOPTION1 = true
	MYOPTION2 = false
	MYOPTION3 = false
	MYOPTION4 = false
	QUOTE = MyNIVEnglishBibleQuotes[DATE]
GuildQuoteOTD:SetText(QUOTE)
	MyGuildMOTDVars.MQ = i
	return;
   elseif MYOPTION2 ~= MyGuildMOTDVars.MYSAVEDOPTION2 then
	MyGuildMOTDVars.MYSAVEDOPTION1 = false
	MyGuildMOTDVars.MYSAVEDOPTION2 = true
	MyGuildMOTDVars.MYSAVEDOPTION3 = false
	MyGuildMOTDVars.MYSAVEDOPTION4 = false
	MYOPTION1 = false
	MYOPTION2 = true
	MYOPTION3 = false
	MYOPTION4 = false
	QUOTE = MyPresidentialQuotes[DATE]
GuildQuoteOTD:SetText(QUOTE)
	MyGuildMOTDVars.MQ = i
	return;
   elseif MYOPTION3 ~= MyGuildMOTDVars.MYSAVEDOPTION3 then
	MyGuildMOTDVars.MYSAVEDOPTION1 = false
	MyGuildMOTDVars.MYSAVEDOPTION2 = false
	MyGuildMOTDVars.MYSAVEDOPTION3 = true
	MyGuildMOTDVars.MYSAVEDOPTION4 = false
	MYOPTION1 = false
	MYOPTION2 = false
	MYOPTION3 = true
	MYOPTION4 = false
	QUOTE = MyHumorousQuotes[DATE]
GuildQuoteOTD:SetText(QUOTE)
	MyGuildMOTDVars.MQ = i
	return;
   end

end

function GM:MyGuildMOTDDefaultDelay()
	self:ScheduleTimer("MyGuildMOTDDefaultBroadcast", MyGuildMOTDVars.MyDelay)
end

function GM:MyGuildMOTDDefaultBroadcast()
	MyGuildMOTDVars.ADM = IncludeADM:GetChecked()
	if MyGuildMOTDVars.ADM == 1 then
	   SendChatMessage(MyGuildMOTDDefault, "GUILD") 
	   GM:MyGuildMOTDQOTDDelay()
	return;

	else
	GM:MyGuildMOTDQOTDBroadcast() -- Broadcast Immediately if the default message isn't being shown.
				      -- since we already had a pause scheduled before this message.
	end
end

function GM:MyGuildMOTDQOTDDelay()
	self:ScheduleTimer("MyGuildMOTDQOTDBroadcast", MyGuildMOTDVars.MyDelay)
end

function GM:MyGuildMOTDQOTDBroadcast()
	MyGuildMOTDVars.QOTD = IncludeQOTD:GetChecked()
	if MyGuildMOTDVars.QOTD == 1 then SendChatMessage(QUOTE, "GUILD") end
end

function GM:BroadcastMessage()

	if CanEditMOTD() then
		if MyGuildMOTDTimer ~= 0 then
		   if MYMOTD ~= "" or nil then
		   MyGMOTDResetter = 1 -- Lets the mod know that we are the one that reset it.
		   GuildSetMOTD(MYMOTD)
		   GM:SetUpTimer() -- Ensures that we go back to regular broadcasts
		   GM:MyGuildMOTDDefaultDelay()
		   else
		   GM:Print("You do not have a Guild MOTD text set, or the MyGuildMOTD mod was unable to find it.  Finishing the broadcast of any additional messages...")
		   MYMOTD = GetGuildRosterMOTD()
		   GM:MyGuildMOTDDefaultDelay()
		   end
		end
	else
	GM:Print("You Do Not Have Permission to Edit the Guild MOTD")		
	end
end

function GM:Slash(msg)
MyType = type(tonumber(msg))

	if msg then

	 	if strlower(msg) == "toggle" then
			GM:CFToggle()
		else
			GM:Print("|cff9999ffFormat:|r\n\"/MyGMOTD toggle or /MyGuildMOTD toggle\" opens up the GUI menu.\nThe current interval is |cff9999ff"..MyGuildMOTDTimer.."|r minutes with less than |cff9999ff"..(math.ceil((GM:TimeLeft(GMActiveTimer))/60)).."|r minutes remaining.")
			return;
		end
	end
end
